proc DllEntryPoint hinstDLL,fdwReason,lpvReserved

        mov     eax,1
        cmp     dword[fdwReason],eax
        jne     .end
        stdcall DllMain,dword[hinstDLL],eax,dword[lpvReserved]
        .end:
        ret
endp

proc DllMain hinstDLL,fdwReason,lpvReserved

        locals
                szModuleFilename rw MAX_PATH
        endl

        lea     eax,[szModuleFilename]
        stdcall GetModuleFileNameSafe,dword[hinstDLL],eax,MAX_PATH
        test    eax,eax
        jz      .end
        lea     eax,[szModuleFilename]
        stdcall GetIniFileName,ini_filename,eax
        test    eax,eax
        jz      .end
        mov     eax,1
        .end:
        ret
endp

proc GetIniFileNameW lpOutFileName,lpInFileName

        locals
                szModuleDirectory rw MAX_PATH
                szNewExtension du '.ini',0
        endl

        push    esi edi
        mov     esi,dword[lpInFileName]
        ccall   wcsnlen,esi,MAX_PATH
        lea     ecx,[eax-1]
        cmp     ecx,MAX_PATH-1
        jae     .error
        shl     eax,1
        mov     edi,dword[lpOutFileName]
        stdcall CopyMemory,edi,esi,eax
        lea     eax,[szNewExtension]
        invoke  PathRenameExtensionW,edi,eax
        test    eax,eax
        jz      .error

        .ok:
        mov     eax,1
        pop     edi esi
        ret

        .error:
        xor     eax,eax
        pop     edi esi
        ret
endp

proc InitPatch

        stdcall GetGameVersionInfo
        test    eax,eax
        jz      .end
        stdcall ReadIniSettings
        mov     eax,1
        cmp     dword[ini_main_enable],0
        je      .end
        stdcall ApplyPatches
        .end:
        ret
endp

proc ReadIniSettings

        push    ebx
        mov     ebx,ini_filename
        invoke  GetPrivateProfileInt,sec_main,key_enable,dword[def_enable],ebx
        mov     dword[ini_main_enable],eax
        invoke  GetPrivateProfileInt,sec_options,key_globalfps,dword[def_globalfps],ebx
        mov     dword[ini_opts_globalfps],eax
        invoke  GetPrivateProfileInt,sec_options,key_excontrols,dword[def_excontrols],ebx
        mov     dword[ini_opts_excontrols],eax
        invoke  GetPrivateProfileInt,sec_options,key_exgraphics,dword[def_exgraphics],ebx
        mov     dword[ini_opts_exgraphics],eax
        invoke  GetPrivateProfileInt,sec_options,key_exswitches,dword[def_exswitches],ebx
        mov     dword[ini_opts_exswitches],eax
        pop     ebx
        ret
endp

proc GetGameVersionInfo

        locals
                moduleinfo MODULEINFO
                version_str rb 16
                sizeof.version_str = 16
                shortversion dd ?
        endl

        push    ebx esi edi
        lea     ebx,[moduleinfo]
        invoke  GetCurrentProcess
        mov     esi,eax

        ;get BaseAddress
        stdcall GetModuleInfo,0,ebx,sizeof.MODULEINFO
        test    eax,eax
        jz      .end
        mov     eax,dword[moduleinfo.lpBaseOfDll]
        mov     dword[DefBaseAddress],0x00400000
        mov     dword[CurBaseAddress],eax

        ;compare version strings
        lea     edi,[version_str]

        .ver_56: ;Divinity2.exe
        mov     dword[shortversion],56
        mov     eax,dword[VER_v1_4_700_56_addr]
        sub     eax,dword[DefBaseAddress]
        add     eax,dword[moduleinfo.lpBaseOfDll]
        invoke  ReadProcessMemory,esi,eax,edi,sizeof.version_str,0
        test    eax,eax
        jz      .ver_57
        stdcall EqualMemory,edi,VER_v1_4_700_56_str,sizeof.VER_v1_4_700_56_str
        test    eax,eax
        jnz     .end

        .ver_57: ;Divinity2-debug.exe
        mov     dword[shortversion],57
        mov     eax,dword[VER_v1_4_700_57_addr]
        sub     eax,dword[DefBaseAddress]
        add     eax,dword[moduleinfo.lpBaseOfDll]
        invoke  ReadProcessMemory,esi,eax,edi,sizeof.version_str,0
        test    eax,eax
        jz      .error
        stdcall EqualMemory,edi,VER_v1_4_700_57_str,sizeof.VER_v1_4_700_57_str
        test    eax,eax
        jnz     .end

        .error:
        or      dword[shortversion],-1
        xor     eax,eax

        .end:
        mov     ecx,dword[shortversion]
        mov     dword[GameShortVersion],ecx
        pop     edi esi ebx
        ret
endp

proc ApplyPatches

        xor     eax,eax
        cmp     dword[GameShortVersion],56
        je      .normal
        cmp     dword[GameShortVersion],57
        je      .debug
        .end:
        ret

        .normal:
        stdcall ApplyPatchesNormal
        jmp     .end

        .debug:
        stdcall ApplyPatchesDebug
        jmp     .end
endp
